//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
//
//  񂽂摜r[A(EasyGraphicViewer)
//
//  frmMain
//
//  쐬ҁ@@@@FɉÒq
//  Jn쐬@@F2005/06/18
//      @@F
//  ŏIXV@@F
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, FileCtrl, Menus, ComCtrls, ToolWin, Jpeg,
  IniFiles, ImgList;

type
  TfrmMain = class(TForm)
    stbMain: TStatusBar;
    splMain: TSplitter;
    tlbMain: TToolBar;
    tlbMainEnd: TToolButton;
    pnlTree: TPanel;
    trvDir: TDirectoryListBox;
    pnlDrv: TPanel;
    cboDrv: TDriveComboBox;
    pnlList: TPanel;
    lstFile: TFileListBox;
    pnlPath: TPanel;
    mnuMain: TMainMenu;
    mnuFile: TMenuItem;
    scbGrh: TScrollBox;
    mnuFileX: TMenuItem;
    mnuHelp: TMenuItem;
    mnuImg: TMenuItem;
    mnuHelpH: TMenuItem;
    mnuHelpC: TMenuItem;
    mnuHelpBar: TMenuItem;
    mnuHelpA: TMenuItem;
    mnuImgC: TMenuItem;
    ToolButton2: TToolButton;
    tlbMainOpen: TToolButton;
    imgListTlb: TImageList;
    txtPath: TEdit;
    mnuImgOpen: TMenuItem;
    tlbMainClose: TToolButton;
    mnuSlide: TMenuItem;
    mnuSlideOpen: TMenuItem;
    ToolButton1: TToolButton;
    tlbMainSlide: TToolButton;
    procedure splMainMoved(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lstFileClick(Sender: TObject);
    procedure trvDirChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NewImgClick(Sender: TObject);
    procedure mnuFileXClick(Sender: TObject);
    procedure mnuImgCClick(Sender: TObject);
    procedure mnuHelpAClick(Sender: TObject);
    procedure mnuImgOpenClick(Sender: TObject);
    procedure tlbMainEndClick(Sender: TObject);
    procedure tlbMainOpenClick(Sender: TObject);
    procedure tlbMainCloseClick(Sender: TObject);
    procedure mnuSlideOpenClick(Sender: TObject);
    procedure tlbMainSlideClick(Sender: TObject);
    procedure mnuHelpHClick(Sender: TObject);
    procedure mnuHelpCClick(Sender: TObject);

  private
    { Private 錾 }
    NewFrm: array[0..299] of TForm;                                              //TFrom Objects
    mintImgCnt: Integer;                                                        //TlC\
    mintFrmCnt: Integer;                                                        //C[WtH[\
    mstrPath: String;                                                           //st@C̃pX
    procedure SetCtrlPos();                                                     //Rg[̈ʒuĐݒ
    procedure ShowThumbnail();                                                  //TlC\
    procedure AppException(Sender: TObject; E: Exception);                      //O

  public
    { Public 錾 }
    NewImg: array[0..299] of TImage;                                             //TImage Objects
  end;

var
  frmMain: TfrmMain;

const
  { IniFile }
  INIFILE_NM        = 'STATE.INI';                                              //INIt@C
  SEC_WIN           = 'WINDOWS';                                                //INIt@CZNV@WINDOWS
  WIN_KEY_TOP       = 'TOP';                                                    //INIt@CL[@TOP
  WIN_KEY_LEFT      = 'LEFT';                                                   //INIt@CL[@LEFT
  WIN_KEY_WIDTH     = 'WIDTH';                                                  //INIt@CL[@HEIGHT
  WIN_KEY_HEIGHT    = 'HEIGHT';                                                 //INIt@CL[@WIDTH
  SEC_DIR           = 'DIRECTORY';                                              //INIt@CZNV@DIRECTORY
  DIR_KEY_DIR       = 'DIRECTORY';                                              //INIt@CL[@DIRECTORY

implementation

uses about, slide;

{$R *.dfm}

//------------------------------------------------------------------------------
//  Event
//
//  splMainMoved
//------------------------------------------------------------------------------
procedure TfrmMain.splMainMoved(Sender: TObject);
begin
    //Rg[̈ʒuĐݒ
    SetCtrlPos;
end;

//------------------------------------------------------------------------------
//  Event
//
//  splMainMoved
//------------------------------------------------------------------------------
procedure TfrmMain.FormResize(Sender: TObject);
begin
    //Rg[̈ʒuĐݒ
    SetCtrlPos;
end;

//******************************************************************************
//  procedure SetCtrlPos
//  Rg[̈ʒuĐݒ
//  In     :
//  Out    :
//  Return :
//******************************************************************************
procedure TfrmMain.SetCtrlPos();
begin
    //wb_[
    cboDrv.Width := pnlDrv.Width;
    txtPath.Width := pnlPath.Width;
end;

//------------------------------------------------------------------------------
//  Event
//
//  FormCreate
//------------------------------------------------------------------------------
procedure TfrmMain.FormCreate(Sender: TObject);
var
    intTop      :   Integer;
    intLeft     :   Integer;
    intHeight   :   Integer;
    intWidth    :   Integer;
    strDir      :   String;
    objIniFile  :   TIniFile;
begin
    //O
    Application.OnException := AppException;

    //W[ϐ̏
    mintImgCnt := 0;
    mintFrmCnt := 0;

    //st@C̃pX擾
    mstrPath := ExtractFilePath(Application.ExeName);

    //wvt@C̃pX擾
    Application.HelpFile := ExtractFilePath(ParamStr(0)) + 'GraphicViewer.hlp';

    //INIt@COIԂ擾
    objIniFile := TIniFile.Create(mstrPath + '\' + INIFILE_NM);
    try
        with objIniFile do
        begin
            intTop :=
                ReadInteger(SEC_WIN, WIN_KEY_TOP, 0);
            intLeft :=
                ReadInteger(SEC_WIN, WIN_KEY_LEFT, 0);
            intHeight :=
                ReadInteger(SEC_WIN, WIN_KEY_HEIGHT,
                                                frmMain.Constraints.MinHeight);
            intWidth :=
                ReadInteger(SEC_WIN, WIN_KEY_WIDTH,
                                                frmMain.Constraints.MinWidth);
            strDir :=
                ReadString(SEC_DIR, DIR_KEY_DIR,
                                                trvDir.Directory);
        end;
    finally
        objIniFile.Free;
    end;

    with frmMain do
    begin
        Top     :=  intTop;
        Left    :=  intLeft;
        Height  :=  intHeight;
        Width   :=  intWidth;
    end;

    //w肳ꂽtH_̃pX\
    trvDir.Directory := strDir;
    txtPath.Text := trvDir.Directory;
end;

//------------------------------------------------------------------------------
//  Event
//
//  lstFileClick
//------------------------------------------------------------------------------
procedure TfrmMain.lstFileClick(Sender: TObject);
begin
    //TlC\
    ShowThumbnail;
end;

//******************************************************************************
//  procedure ShowThumb
//  TlC\
//  In     :
//  Out    :
//  Return :
//******************************************************************************
procedure TfrmMain.ShowThumbnail();
var
    idx: Integer;
    intCnt: Integer;
    strFileNm: String;
begin
    //IuWFNg̉
    for idx:=0 to mintFrmCnt-1 do
    begin
        if (idx > 299) then break;
        NewFrm[idx].Free;
    end;
    for idx:=0 to mintImgCnt-1 do
    begin
        if (idx > 299) then break;
        NewImg[idx].Free;
    end;

    //ϐ̏
    mintImgCnt := 0;
    mintFrmCnt := 0;
    intCnt := 0;

    for idx:=0 to lstFile.Items.Count-1 do
    begin
        if (lstFile.Selected[idx] = True) then
        begin
            strFileNm := trvDir.Directory + '\' + lstFile.Items.Strings[idx];

            //TImage𓮓Iɍ쐬
            NewImg[intCnt] := TImage.Create(Self);
            NewImg[intCnt].Parent := scbGrh;
            NewImg[intCnt].SetBounds(8+(160+8)*intCnt, 8, 160, 120);
            NewImg[intCnt].Proportional := True;
            NewImg[intCnt].Center := True;
            NewImg[intCnt].Cursor := crHandPoint;
            NewImg[intCnt].Hint := strFileNm;
            NewImg[intCnt].OnClick := NewImgClick;

            //I𒆂̃t@CTImageɕ\
            NewImg[intCnt].Picture.LoadFromFile(strFileNm);

            inc(intCnt);

            if (intCnt > 299) then
            begin
                ShowMessage('TlCɕ\ł摜300܂łłB');
                break;
            end;
        end;
    end;
    mintImgCnt := intCnt;

    //Xe[^Xo[\
    stbMain.SimpleText := IntToStr(mintImgCnt) + ' ̉摜t@CI';
end;

//------------------------------------------------------------------------------
//  Event
//
//  trvDirChange
//------------------------------------------------------------------------------
procedure TfrmMain.trvDirChange(Sender: TObject);
begin
    //w肳ꂽtH_̃pX\
    txtPath.Text := trvDir.Directory;

    //Xe[^Xo[
    stbMain.SimpleText := '0 ̉摜t@CI';
end;

//------------------------------------------------------------------------------
//  Event
//
//  FormDestroy
//------------------------------------------------------------------------------
procedure TfrmMain.FormDestroy(Sender: TObject);
var
    intTop      :   Integer;
    intLeft     :   Integer;
    intHeight   :   Integer;
    intWidth    :   Integer;
    objIniFile  :   TIniFile;
begin
    //INIt@CɏIԂ擾
    intTop      :=  frmMain.Top;
    intLeft     :=  frmMain.Left;
    intHeight   :=  frmMain.Height;
    intWidth    :=  frmMain.Width;

    objIniFile  :=  TIniFile.Create(mstrPath + '\' + INIFILE_NM);

    try
        with objIniFile do
        begin
            WriteInteger(SEC_WIN, WIN_KEY_TOP, intTop);
            WriteInteger(SEC_WIN, WIN_KEY_LEFT, intLeft);
            WriteInteger(SEC_WIN, WIN_KEY_HEIGHT, intHeight);
            WriteInteger(SEC_WIN, WIN_KEY_WIDTH, intWidth);
            WriteString(SEC_DIR, DIR_KEY_DIR, trvDir.Directory);
        end;
    finally
        objIniFile.Free;
    end;
end;

//******************************************************************************
//  procedure NewImgClick
//  TImage Click Event
//  In     :
//  Out    :
//  Return :
//******************************************************************************
procedure TfrmMain.NewImgClick(Sender: TObject);
var
    imgShow: TImage;
    imgSender: TImage;
begin
    if (mintFrmCnt > 299) then
    begin
        ShowMessage('\ł摜300܂łłB');
        exit;
    end;

    //C[Wʂ\
    NewFrm[mintFrmCnt] := TForm.Create(Self);
    NewFrm[mintFrmCnt].Position := poDefaultPosOnly;
    NewFrm[mintFrmCnt].BorderStyle := bsSizeable;
    NewFrm[mintFrmCnt].HelpContext := 1;

    imgSender := (Sender As TImage);
    imgShow := TImage.Create(Self);
    imgShow.Parent := NewFrm[mintFrmCnt];
    imgShow.Center := True;
    imgShow.Align := alClient;
    imgShow.Stretch := True;
    imgShow.Proportional := True;
    imgShow.Picture := imgSender.Picture;

    NewFrm[mintFrmCnt].Caption := imgSender.Hint;

    //ʕ`}~
    LockWindowUpdate(NewFrm[mintFrmCnt].ClientHandle);

    NewFrm[mintFrmCnt].Show;
    NewFrm[mintFrmCnt].Width := 640;
    NewFrm[mintFrmCnt].Height := 480;

    //ʕ`ĊJ
    LockWindowUpdate(0);

    inc(mintFrmCnt);
end;

//******************************************************************************
//  procedure AppException
//  O
//  In     :
//  Out    :
//  Return :
//******************************************************************************
procedure TfrmMain.AppException(Sender: TObject; E: Exception);
begin
//    ShowMessage(E.Message);
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuFileXClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuFileXClick(Sender: TObject);
begin
    //ʂ
    Close;
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuImgCClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuImgCClick(Sender: TObject);
var
    idx: Integer;
begin
    //IuWFNg̉
    for idx:=0 to mintFrmCnt-1 do
    begin
        if (idx > 299) then break;
        NewFrm[idx].Free;
    end;

    //ϐ̏
    mintFrmCnt := 0;
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuHelpAClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuHelpAClick(Sender: TObject);
begin
    frmAbout.ShowModal;
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuImgOpenClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuImgOpenClick(Sender: TObject);
var
    idx: Integer;
begin
    for idx:=0 to mintImgCnt-1 do
    begin
        if (mintFrmCnt > 299) then
        begin
            ShowMessage('\ł摜300܂łłB');
            break;
        end;
        NewImgClick(NewImg[idx]);
    end;
end;

//------------------------------------------------------------------------------
//  Event
//
//  tlbMainEndClick
//------------------------------------------------------------------------------
procedure TfrmMain.tlbMainEndClick(Sender: TObject);
begin
    mnuFileXClick(Sender);
end;

//------------------------------------------------------------------------------
//  Event
//
//  tlbMainOpenClick
//------------------------------------------------------------------------------
procedure TfrmMain.tlbMainOpenClick(Sender: TObject);
begin
    mnuImgOpenClick(Sender);
end;

//------------------------------------------------------------------------------
//  Event
//
//  tlbMainCloseClick
//------------------------------------------------------------------------------
procedure TfrmMain.tlbMainCloseClick(Sender: TObject);
begin
    mnuImgCClick(Sender);
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuSlideOpenClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuSlideOpenClick(Sender: TObject);
begin
    //摜IĂȂȂ珈𔲂
    if (mintImgCnt < 1) then exit;

    //XChʂ\
    frmSlide.imgSlide.Picture := NewImg[0].Picture;
    frmSlide.Caption := NewImg[0].Hint;
    frmSlide.scbSlide.Min := 1;
    frmSlide.scbSlide.Max := mintImgCnt;
    frmSlide.ShowModal;
end;

//------------------------------------------------------------------------------
//  Event
//
//  tlbMainSlideClick
//------------------------------------------------------------------------------
procedure TfrmMain.tlbMainSlideClick(Sender: TObject);
begin
    mnuSlideOpenClick(Sender);
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuHelpHClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuHelpHClick(Sender: TObject);
begin
    Application.HelpCommand(HELP_CONTENTS, 0);
end;

//------------------------------------------------------------------------------
//  Event
//
//  mnuHelpCClick
//------------------------------------------------------------------------------
procedure TfrmMain.mnuHelpCClick(Sender: TObject);
begin
    Application.HelpCommand(HELP_FINDER, 0);
end;

end.

